using System;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Events;
namespace JWM
{
    public class JWM
    {
        static string JWMTag = " <color=red>[JWM] <color=white>";
        public static void Main()

        {

            CategoryBuilder.Create("John Wick Mod", "A catalogue of John Wick characters and items.", ModAPI.LoadSprite("logo_category.png"));
            #region People
            //Viggo Tarasov
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = JWMTag + "Viggo Tarasov",
                DescriptionOverride = "It's not what you did, son, that angers me so. It's who you did it to.",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Viggo-Tarasov-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    var skin = ModAPI.LoadTexture("Sprites/People/Viggo Tarasov/Viggo-Tarasov-skin.png");
                    var person = Instance.GetComponent<PersonBehaviour>();
                    person.SetBodyTextures(skin);
                }

            }

            );
            //Iosef Tarasov
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = JWMTag + "Iosef Tarasov",
                DescriptionOverride = "Are you scared of the fuckin' boogeyman? I'm not.",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Iosef-Tarasov-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    var skin = ModAPI.LoadTexture("Sprites/People/Iosef Tarasov/Iosef-Tarasov-skin.png");
                    var person = Instance.GetComponent<PersonBehaviour>();
                    person.SetBodyTextures(skin);
                }

            }

            );
            //John Wick
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = JWMTag + "John Wick",
                DescriptionOverride = "It wasn't just a puppy.",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/John-Wick-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    var skin = ModAPI.LoadTexture("Sprites/People/John Wick/John-Wick-skin.png");
                    var person = Instance.GetComponent<PersonBehaviour>();
                    person.SetBodyTextures(skin);

                    PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Sprites/People/John Wick/John-Wick-skin.png"), "John Wick's Classic Suit", "Baba Yaga");
                    PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Sprites/People/John Wick/Jacketless.png"), "John Wick's Jacketless Suit", "Jacketless");
                    PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Sprites/People/John Wick/battle_damaged_wick.png"), "John Wick's Battle Damaged Suit", "Jacketless and bloody");
                    PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Sprites/People/John Wick/all_black.png"), "John Wick's All-Black Suit", "Back in black");
                    PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Sprites/People/John Wick/silverhand.png"), "Johnny Silverhand's Classic Rocker Outfit", "Wake the fuck up, samurai.");
                    PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Sprites/People/John Wick/Neo.png"), "John Wick's Neo Cosplay", "Heard he's a big fan of Keanu Reeves.");
                }

            }

            );
            //Wickson
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = JWMTag + "Wickson",
                DescriptionOverride = "Someone took his walkie talkie, he's not happy.",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Wickson-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    var skin = ModAPI.LoadTexture("Sprites/People/Wickson/Wickson.png");
                    var flesh = ModAPI.LoadTexture("Sprites/People/Wickson/wickson flesh layer.png");
                    var bone = ModAPI.LoadTexture("Sprites/People/Wickson/wickson bone layer.png");
                    var person = Instance.GetComponent<PersonBehaviour>();
                    person.SetBodyTextures(skin, flesh, bone, 1);
                    person.Limbs[0].gameObject.AddComponent<RogVoice>();


                    person.BoneBreakClips = new AudioClip[]
                    {
                ModAPI.LoadSound("Sounds/rogbrok.wav"),
                ModAPI.LoadSound("Sounds/roghurt.wav")
                     };
                    //use the helper function to set each texture
                    //parameters are as follows: 
                    //  skin texture, flesh texture, bone texture, sprite scale
                    //you can pass "null" to fall back to the original texture

                    //change procedural damage colours if they interfere with your texture (rgb 0-255)
                    person.SetBruiseColor(28, 0, 17); //main bruise colour. purple-ish by default
                    person.SetSecondBruiseColor(6, 0, 9); //second bruise colour. red by default
                    person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
                    person.SetRottenColour(255, 255, 255); // rotten/zombie colour. light yellow/green by default
                    person.SetBloodColour(6, 0, 9); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                }
            }


               );
            //Ares
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = JWMTag + "Ares",
                DescriptionOverride = "Be seeing you soon, John Wick.",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Ares-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    var skin = ModAPI.LoadTexture("Sprites/People/Ares/Ares-skin.png");
                    var person = Instance.GetComponent<PersonBehaviour>();
                    person.SetBodyTextures(skin);
                }

            }



            );
            //Cassian
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = JWMTag + "Cassian",
                DescriptionOverride = "You killed my ward. Someone I was close to. An eye for an eye, John, you know how it goes.",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Cassian-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    var skin = ModAPI.LoadTexture("Sprites/People/Cassian/Cassian-skin.png");
                    var person = Instance.GetComponent<PersonBehaviour>();
                    person.SetBodyTextures(skin);
                }

            }



            );
            //Santino
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = JWMTag + "Santino D'Antonio",
                DescriptionOverride = "No wife, no dog, no home. You have nothing, John. Vengeance is all you have left.",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Santino-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    var skin = ModAPI.LoadTexture("Sprites/People/Santino D'Antonio/Santino-skin.png");
                    var person = Instance.GetComponent<PersonBehaviour>();
                    person.SetBodyTextures(skin);
                }

            }



            );
            //Avi
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = JWMTag + "Avi",
                DescriptionOverride = "Viggo, English, please! Come on.",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Avi-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    var skin = ModAPI.LoadTexture("Sprites/People/Avi/Avi-skin.png");
                    var person = Instance.GetComponent<PersonBehaviour>();
                    person.SetBodyTextures(skin);
                }

            }



            );
            //Aurelio
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = JWMTag + "Aurelio",
                DescriptionOverride = "Yeah, well, because he stole John Wick's car, sir, and, uh, killed his dog.",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Aurelio-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    var skin = ModAPI.LoadTexture("Sprites/People/Aurelio/Aurelio-skin.png");
                    var person = Instance.GetComponent<PersonBehaviour>();
                    person.SetBodyTextures(skin);
                }

            }



            );
            //Charon
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = JWMTag + "Charon",
                DescriptionOverride = "How good to see you again so soon, Mr. Wick.",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Charon-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    var skin = ModAPI.LoadTexture("Sprites/People/Charon/Charon-skin.png");
                    var person = Instance.GetComponent<PersonBehaviour>();
                    person.SetBodyTextures(skin);
                }

            }



            );
            //Marcus
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = JWMTag + "Marcus",
                DescriptionOverride = "There's no rhyme or reason to this life. It's days like today scattered among the rest.",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Marcus-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    var skin = ModAPI.LoadTexture("Sprites/People/Marcus/Marcus-skin.png");
                    var person = Instance.GetComponent<PersonBehaviour>();
                    person.SetBodyTextures(skin);
                }

            }



            );
            //Winston
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = JWMTag + "Winston",
                DescriptionOverride = "Now, as I recall, weren't you the one tasked to dole out the beatings, not to receive them?",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Winston-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    var skin = ModAPI.LoadTexture("Sprites/People/Winston/Winston-skin.png");
                    var person = Instance.GetComponent<PersonBehaviour>();
                    person.SetBodyTextures(skin);
                }

            }



            );
            //Abram
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = JWMTag + "Abram Tarasov",
                DescriptionOverride = "Can a man like you know peace?",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Abram-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    var skin = ModAPI.LoadTexture("Sprites/People/Abram/Abram-skin.png");
                    var person = Instance.GetComponent<PersonBehaviour>();
                    person.SetBodyTextures(skin);
                }

            }



            );
            //Bowery King
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = JWMTag + "Bowery King",
                DescriptionOverride = "Somebody, please! Get this man a gun!",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Bowery-King-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    var skin = ModAPI.LoadTexture("Sprites/People/Bowery King/Bowery King-skin.png");
                    var person = Instance.GetComponent<PersonBehaviour>();
                    person.SetBodyTextures(skin);
                }

            }



            );

            //Adjudicator
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = JWMTag + "The Adjudicator",
                DescriptionOverride = "What are we going to do with John Wick?",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Adjudicator-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    var skin = ModAPI.LoadTexture("Sprites/People/Adjudicator/The-Adjudicator.png");
                    var person = Instance.GetComponent<PersonBehaviour>();
                    person.SetBodyTextures(skin);

                
                }

            }

            );
            //Zero
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = JWMTag + "Zero",
                DescriptionOverride = "Hey, John. That was a pretty good fight, huh?",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Zero-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    var skin = ModAPI.LoadTexture("Sprites/People/Zero/Zero.png");
                    var person = Instance.GetComponent<PersonBehaviour>();
                    person.SetBodyTextures(skin);


                }

            }

            );
            //Sofia
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = JWMTag + "Sofia",
                DescriptionOverride = "He shot my dog.",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Sofia-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    var skin = ModAPI.LoadTexture("Sprites/People/Sofia/Sofia.png");
                    var person = Instance.GetComponent<PersonBehaviour>();
                    person.SetBodyTextures(skin);


                }

            }

            );



            #endregion

            #region Weapons
            //John Wick's Heckler and Koch P30L
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Pistol"),
                NameOverride = JWMTag + "<color=green>[Weapon]<color=white><color=white> John Wick's Heckler and Koch P30L",
                DescriptionOverride = "The iconic handgun used by John Wick",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/John-Wicks-Heckler-and-Koch-P30L-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Weapons/John-Wicks-Heckler-and-Koch-P30L.png");
                    var firearm = Instance.GetComponent<FirearmBehaviour>();
                    Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                    customCartridge.name = "John Wick's Heckler and Koch P30L - Cartridge";
                    customCartridge.Damage *= 0.8f;
                    customCartridge.StartSpeed *= 1.5f;
                    customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
                    customCartridge.Recoil *= 0.7f;
                    customCartridge.ImpactForce *= 0.8f;
                    firearm.Cartridge = customCartridge;
                    firearm.ShotSounds = new AudioClip[] { ModAPI.LoadSound("Sounds/John-Wicks-Heckler-and-Koch-P30L.wav") };
                    Instance.FixColliders();

                }

            }

            );
            //Marcus' Browning Hi-Power
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Pistol"),
                NameOverride = JWMTag + "<color=green>[Weapon]<color=white><color=white> Marcus' Browning Hi-Power",
                DescriptionOverride = "The iconic handgun used by Marcus",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Browning-Hi-Power-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Weapons/Browning-Hi-Power.png");
                    var firearm = Instance.GetComponent<FirearmBehaviour>();
                    Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                    customCartridge.name = "John Wick's Heckler and Koch P30L - Cartridge";
                    customCartridge.Damage *= 0.8f;
                    customCartridge.StartSpeed *= 1.5f;
                    customCartridge.PenetrationRandomAngleMultiplier *= 0.5f;
                    customCartridge.Recoil *= 0.7f;
                    customCartridge.ImpactForce *= 0.8f;
                    firearm.Cartridge = customCartridge;
                    firearm.ShotSounds = new AudioClip[] { ModAPI.LoadSound("Sounds/John-Wicks-Heckler-and-Koch-P30L.wav") };
                    Instance.FixColliders();

                }

            }

            );
            //John Wick's Taran Tactical TR-15 Ultralight
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Assault Rifle"),
                NameOverride = JWMTag + "<color=green>[Weapon]<color=white> John Wick's Taran Tactical TR-15 Ultralight",
                DescriptionOverride = "The same rifle that John threw at some dudes head.",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Taran-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Weapons/JW_Taran_Tactical_TR-1.png",1.66f);
                    Instance.FixColliders();

                }

            }

            );
   
            //Pencil
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Knife"),
                NameOverride = JWMTag + "<color=green>[Weapon]<color=white> Pencil",
                DescriptionOverride = "Once used to kill three men in a bar.",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Pencil-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Weapons/Pencil.png",4.8f);
                    Instance.FixColliders();

                }

            }

            );

            //Smoke Grenade
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = JWMTag + "<color=green>[Weapon]<color=white> Smoke Grenade",
                DescriptionOverride = "Not the only white dust known to disable someone's vision, though the most effective.",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Smoke-Thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Weapons/Smoke_Grendae.png", 1);
                    Instance.FixColliders();
                    Material material = new Material(ModAPI.FindMaterial("Sprites-Default"));
                    Material TrailMaterial = new Material(ModAPI.FindMaterial("Sprites-Default"));
                    material.mainTexture = ModAPI.LoadTexture("Sprites/Weapons/Dust.png");
                    var sound = ModAPI.LoadSound("Sounds/Smoke_Grenade.wav");

                    Instance.AddComponent<UseEventTrigger>().Action = () =>
                    {
                        //add a particle system component to Instance that makes grow in and fade out
                        Instance.GetComponent<AudioSource>().PlayOneShot(sound);
                        GameObject Particle = new GameObject();
                        Particle.transform.SetParent(Instance.transform,false);
                        Particle.AddComponent<ParticleSystem>();
                        var main = Particle.GetComponent<ParticleSystem>().main;
                        main.startSpeed = 0.4f;
                        Particle.GetComponent<ParticleSystemRenderer>().material = material;
                        var coL = Particle.GetComponent<ParticleSystem>().colorOverLifetime;
                        Particle.GetComponent<ParticleSystem>().simulationSpace = ParticleSystemSimulationSpace.World;
                        coL.color = new ParticleSystem.MinMaxGradient(new Gradient()
                        {
                            mode = GradientMode.Blend,
                            alphaKeys = new GradientAlphaKey[]
                            {
                                new GradientAlphaKey(0,0),
                                new GradientAlphaKey(1,0.2f),
                                new GradientAlphaKey(0,1)
                            },
                            colorKeys = new GradientColorKey[]
                            {
                                new GradientColorKey(new Color(0.3f,0.3f,0.3f),0),
                                new GradientColorKey(new Color(0.3f,0.3f,0.3f),1)
                            }
                        });
                        coL.enabled = true;
                        //Make the particle system Rotate over time
                        var rot = Particle.GetComponent<ParticleSystem>().rotationOverLifetime;
                        rot.enabled = true;
                        //make the particle system shape radius 0
                        var shape = Particle.GetComponent<ParticleSystem>().shape;
                        shape.enabled = true;
                        shape.radius = 0;
                        //Make the particle system size over time to grow
                        var size = Particle.GetComponent<ParticleSystem>().sizeOverLifetime;
                        size.enabled = true;
                        size.size = new ParticleSystem.MinMaxCurve(0.5f, new AnimationCurve(new Keyframe(0, 4), new Keyframe(0.5f, 5), new Keyframe(1, 6)));
                        main.startLifetime = 12;
                        Particle.GetComponent<ParticleSystemRenderer>().sortingLayerName = "Top";
                    };

                }

            }

            );

            //Switch Blade
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Knife"),
                NameOverride = JWMTag + "<color=green>[Weapon]<color=white> Switch Blade",
                DescriptionOverride = "Sometimes a comb, sometimes you lose your wallet keys and phone.\n-Interact with it to flip the blade in and out.",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Wick_Knife_thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Weapons/Wick_Knife_Bladeless.png",2.4f);
                    Instance.AddComponent<Switchblade>().newSprite = ModAPI.LoadSprite("Sprites/Weapons/Wick_Knife.png",2.4f);
                    Instance.GetComponent<Switchblade>().FlipSound = ModAPI.LoadSound("Sounds/switch blade.wav");
                    Instance.GetComponent<BoxCollider2D>().size = new Vector2(Instance.GetComponent<BoxCollider2D>().size.x, Instance.GetComponent<BoxCollider2D>().size.y / 2);
                    Instance.GetComponent<BoxCollider2D>().offset = new Vector2(Instance.GetComponent<BoxCollider2D>().offset.x, -0.2f);

                }

            }

            );
            //Colt Python
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Pistol"),
                NameOverride = JWMTag + "<color=green>[Weapon]<color=white><color=white> Colt Python",
                DescriptionOverride = "",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Colt-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Weapons/Colt-Python.png");
                    
                }

            }

            );

            //Pencil
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Brick"),
                NameOverride = JWMTag + "<color=green>[Weapon]<color=white> John's Dog",
                DescriptionOverride = "John's excuse to kill literally thousands of people, pencil or otherwise",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Dogg.png"),
                AfterSpawn = (Instance) =>

                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/tombstone.png");
                    Instance.FixColliders();

                }

            }

            );
            //Katana
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Knife"),
                NameOverride = JWMTag + "<color=green>[Weapon]<color=white> Zero's Katana",
                DescriptionOverride = "Pretty cool.",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/katana-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Weapons/Katana.png");
                    Instance.FixColliders();

                }

            }

            );
            #endregion

            #region Vehicles
            //Boss 429
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Car"),
                NameOverride = JWMTag + "<color=yellow>[Vehicle]<color=white> Boss 429",
                DescriptionOverride = "The wheels of a dogless Man.",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Car-thumb.png"),
                AfterSpawn = (Instance) =>

                {
                    Component.Destroy(Instance.transform.GetChild(0).GetComponent<RandomCarTextureBehaviour>());
                    Instance.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Cars/Johns Bosa/Car Body.png");
                    Instance.transform.GetChild(2).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Cars/Johns Bosa/Car Wheel.png");
                    Instance.transform.GetChild(1).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Cars/Johns Bosa/Car Wheel.png");
                    Instance.transform.GetChild(0).gameObject.GetComponent<CarBehaviour>().WheelJoints[1].anchor = new Vector2(2.0f, -0.8f);
                    Instance.transform.GetChild(0).gameObject.GetComponent<CarBehaviour>().WheelJoints[0].anchor = new Vector2(-1.98f, -0.8f);
                    Instance.transform.GetChild(0).gameObject.GetComponent<AudioSource>().clip = ModAPI.LoadSound("Sounds/Bosa Loop.wav");
                    Instance.transform.GetChild(3).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Cars/Johns Bosa/Car Hood.png");
                    Instance.transform.GetChild(3).transform.localPosition += Vector3.up * 0.05f;
                    Instance.transform.GetChild(0).transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Cars/Johns Bosa/Car Insides.png");
                    GameObject.Destroy(Instance.transform.GetChild(6).gameObject);
                    Instance.transform.GetChild(5).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Cars/Johns Bosa/Car Door.png");
                    Instance.transform.GetChild(5).transform.localPosition = new Vector3(-0.05703688f, 0.1f, 0.0f);
                    Instance.transform.GetChild(4).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Cars/Johns Bosa/Car Boot.png");
                    Instance.transform.GetChild(4).transform.localPosition = new Vector3(-3.1f, 0.1f, 0.0f);

                }

            }

            );
            //Yamaha MT-09
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Car"),
                NameOverride = JWMTag + "<color=yellow>[Vehicle]<color=white> Yamaha MT-09",
                DescriptionOverride = "Two wheels are better than 4... wait, that's not right...",
                CategoryOverride = ModAPI.FindCategory("John Wick Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/foikin_boik_aeee.png"),
                AfterSpawn = (Instance) =>

                {
                    Instance.transform.GetChild(0).gameObject.AddComponent<LegsIgnore>();
                    Component.Destroy(Instance.transform.GetChild(0).GetComponent<RandomCarTextureBehaviour>());
                    Instance.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Cars/Yamaha MT-09/Bike Body.png");
                    Instance.transform.GetChild(0).gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                    {
                        ModAPI.LoadSprite("Sprites/Cars/Yamaha MT-09/Bike_Body_Black.png"),
                        ModAPI.LoadSprite("Sprites/Cars/Yamaha MT-09/Bike_Body_Blue.png"),
                        ModAPI.LoadSprite("Sprites/Cars/Yamaha MT-09/Bike_Body_Orange.png"),
                        ModAPI.LoadSprite("Sprites/Cars/Yamaha MT-09/Bike_Body_Purple.png"),
                        ModAPI.LoadSprite("Sprites/Cars/Yamaha MT-09/Bike_Body_Red.png"),
                        ModAPI.LoadSprite("Sprites/Cars/Yamaha MT-09/Bike_Body_Striped.png"),
                        ModAPI.LoadSprite("Sprites/Cars/Yamaha MT-09/Bike Body.png"),
                    };
                    Instance.transform.GetChild(0).gameObject.FixColliders();
                    Instance.transform.GetChild(2).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Cars/Yamaha MT-09/Bike Wheel.png");
                    Instance.transform.GetChild(1).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Cars/Yamaha MT-09/Bike Wheel.png");
                    Instance.transform.GetChild(7).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Cars/Yamaha MT-09/Engine.png");
                    Physics2D.IgnoreCollision(Instance.transform.GetChild(0).GetComponent<Collider2D>(), Instance.transform.GetChild(2).GetComponent<Collider2D>());
                    Physics2D.IgnoreCollision(Instance.transform.GetChild(0).GetComponent<Collider2D>(), Instance.transform.GetChild(1).GetComponent<Collider2D>());
                    Physics2D.IgnoreCollision(Instance.transform.GetChild(0).GetComponent<Collider2D>(), Instance.transform.GetChild(7).GetComponent<Collider2D>());
                    Physics2D.IgnoreCollision(Instance.transform.GetChild(0).GetComponent<Collider2D>(), Instance.transform.GetChild(8).GetComponent<Collider2D>());
                    Instance.transform.GetChild(7).transform.localPosition = new Vector3(0.04252434f, -0.2721229f);
                    Instance.transform.GetChild(8).transform.localPosition = new Vector3(0.1422426f, 0.1096239f);
                    Instance.transform.GetChild(2).transform.localPosition  = new Vector2(1.018855f, -0.5804803f);
                    Instance.transform.GetChild(1).transform.localPosition = new Vector2(-1.313431f, -0.5804803f);
                    Instance.transform.GetChild(0).gameObject.GetComponent<CarBehaviour>().WheelJoints[1].anchor = new Vector2(1.018855f, -0.5804803f);
                    Instance.transform.GetChild(0).gameObject.GetComponent<CarBehaviour>().WheelJoints[0].anchor = new Vector2(-1.313431f, -0.5804803f);
                    Instance.transform.GetChild(0).gameObject.GetComponent<AudioSource>().clip = ModAPI.LoadSound("Sounds/Bosa Loop.wav");
                    GameObject.Destroy(Instance.transform.GetChild(3).gameObject);
                    GameObject.Destroy(Instance.transform.GetChild(0).transform.GetChild(0).gameObject);
                    GameObject.Destroy(Instance.transform.GetChild(6).gameObject);
                    GameObject.Destroy(Instance.transform.GetChild(5).gameObject);
                    GameObject.Destroy(Instance.transform.GetChild(4).gameObject);

                }

            }

            );
            #endregion
        }

    }
}

//make a class that logs an objects local position and says its name

public class LogPosition : MonoBehaviour
{
    private void Update()
    {
        Debug.Log(gameObject.name + " " + transform.localPosition.y);
    }
}

//make a class that has a function to toggle an 2d box collider size to half its size and changes the offset to half its size and changes the sprite to a different one and back
public class Switchblade : MonoBehaviour,Messages.IUse
{
    private BoxCollider2D boxCollider;
    private SpriteRenderer spriteRenderer;
    private Sprite originalSprite;
    public Sprite newSprite;
    public AudioSource auds;
    public AudioClip FlipSound;
    private bool isColliderOn = false;

    public void Use(ActivationPropagation activation)
    {
        if (isColliderOn)
        {
            boxCollider.size = new Vector2(boxCollider.size.x, boxCollider.size.y / 2);
            boxCollider.offset = new Vector2(boxCollider.offset.x, -0.2f);
            spriteRenderer.sprite = originalSprite;
            isColliderOn = false;
            auds.PlayOneShot(FlipSound);
            GetComponent<PhysicalBehaviour>().Properties.Sharp = false;
            GetComponent<PhysicalBehaviour>().RefreshOutline();

        }
        else
        {
            boxCollider.size = new Vector2(boxCollider.size.x, boxCollider.size.y * 2);
            boxCollider.offset = new Vector2(boxCollider.offset.x, -0.08f);
            spriteRenderer.sprite = newSprite;
            isColliderOn = true;
            auds.PlayOneShot(FlipSound);
            GetComponent<PhysicalBehaviour>().Properties.Sharp = true;
            GetComponent<PhysicalBehaviour>().RefreshOutline();
        }
    }

    private void Start()
    {
        boxCollider = GetComponent<BoxCollider2D>();
        spriteRenderer = GetComponent<SpriteRenderer>();
        originalSprite = spriteRenderer.sprite;
        GameObject AudioObject = new GameObject();
        AudioObject.transform.SetParent(transform, false);
        auds = AudioObject.AddComponent<AudioSource>();
        auds.spatialBlend = 1;
        GetComponent<PhysicalBehaviour>().Properties.Sharp = false;
    }
    
}

public class RogVoice : MonoBehaviour
{
    public AudioClip PantsFeetSong = ModAPI.LoadSound("Sounds/rogsong.wav");
 //   public AudioClip AvengersSong = ModAPI.LoadSound("Wilson Evolved.wav");
    public AudioClip Pain = ModAPI.LoadSound("Sounds/rogpain.wav");
    public AudioClip Dead = ModAPI.LoadSound("Sounds/RogKill.wav");
    public AudioClip sleepp = ModAPI.LoadSound("Sounds/rog sleep.wav");
    public AudioSource audio;
    List<GameObject> Hands = new List<GameObject>();
    bool SetDead = false;
    bool Sleep = false;
    bool Sword = false;
    public void Start()
    {
        GameObject AUdio = new GameObject();
        AUdio.transform.SetParent(transform, false);
        audio = AUdio.gameObject.AddComponent<AudioSource>();
        audio.spatialBlend = 1;
        AUdio.AddComponent<AudioDistortionFilter>().distortionLevel = 0.8f;
        item = GetComponent<LimbBehaviour>();
        foreach (var item in transform.parent.GetComponentsInChildren<GripBehaviour>())
        {
            Hands.Add(item.gameObject);
        }
    }

    public LimbBehaviour item;
    public void Update()
    {
        if (item.IsConsideredAlive && item.Person.Consciousness > 0.8f)
        {
            Sleep = false;
            SetDead = false;
            if (!(item.Person.ShockLevel > 0) && ((!Sword && audio.clip != PantsFeetSong)))
            {
                if (!Sword)
                    audio.clip = PantsFeetSong;
           //     else audio.clip = AvengersSong;
                audio.loop = true;
                audio.Play();
            }
            else
            {
                if ((item.Person.ShockLevel > 0) && audio.clip != Pain)
                {
                    audio.clip = Pain;
                    audio.loop = true;
                    audio.Play();
                }
            }
        }
        else if (item.Person.Consciousness < 0.8f && !Sleep)
        {
            audio.Stop();
            Sleep = true;
            audio.clip = sleepp;
            audio.loop = false;
            audio.Play();
        }
        else if (!item.IsConsideredAlive && !SetDead)
        {
            SetDead = true;
            audio.clip = Dead;
            audio.loop = false;
            audio.Play();
        }


        //if ((Hands[0].GetComponent<GripBehaviour>().CurrentlyHolding && Hands[0].GetComponent<GripBehaviour>().CurrentlyHolding.name == "The Almighty Sword") || (Hands[1].GetComponent<GripBehaviour>().CurrentlyHolding && Hands[1].GetComponent<GripBehaviour>().CurrentlyHolding.name == "The Almighty Sword"))
        //    Sword = true;
        //else Sword = false;


    }


}


//Make a class that makes any object called legs ignore collision with this object in a certain radius of a casted circle.
public class LegsIgnore : MonoBehaviour
{
    public float Radius = 2f;
    public void Start()
    {

    }

    public void Update()
    {
        foreach (var item in Physics2D.OverlapCircleAll(transform.position, Radius))
        {
            if (item.gameObject.name.Contains("Leg") || item.gameObject.name.Contains("Foot"))
                Physics2D.IgnoreCollision(item.gameObject.GetComponent<Collider2D>(), GetComponent<Collider2D>(), true);
                Physics2D.IgnoreCollision(GetComponent<Collider2D>(), transform.GetChild(2).GetComponent<Collider2D>());
                Physics2D.IgnoreCollision(GetComponent<Collider2D>(), transform.GetChild(1).GetComponent<Collider2D>());
                Physics2D.IgnoreCollision(GetComponent<Collider2D>(), transform.GetChild(7).GetComponent<Collider2D>());
                Physics2D.IgnoreCollision(GetComponent<Collider2D>(), transform.GetChild(8).GetComponent<Collider2D>());
        }
    }
}


